//
//  EjemploTablaDatosTests.m
//  EjemploTablaDatosTests
//
//  Created by imacrcanales on 04/11/12.
//  Copyright (c) 2012 Autentia. All rights reserved.
//

#import <SenTestingKit/SenTestingKit.h>
#import "EjemploTablaDatosTests.h"
#import "AppDelegate.h"
#import "Gestor.h"
#import "GestorPuntuaciones.h"

@implementation EjemploTablaDatosTests


- (void)testGestorCorrecto
{
    AppDelegate* appDelegate = [[UIApplication sharedApplication] delegate];
    STAssertNotNil(appDelegate,@"El delegate es nulo");

    // recuperamos el gestor del delegate
    NSObject* gestor = [appDelegate getGestorPuntuaciones];
    
    STAssertTrue([gestor conformsToProtocol:@protocol(Gestor)],@"El gestor de puntuaciones no es adecuado");
    
    // hacemos un casting
    GestorPuntuaciones* gestorPuntuaciones = (GestorPuntuaciones*)gestor;
    
    // comprovamos que tienen los métodos del contrato
    STAssertTrue( [gestorPuntuaciones respondsToSelector:@selector(sumaPuntuacion:)], @"No tiene el método sumaPuntuación");
    STAssertTrue( [gestorPuntuaciones respondsToSelector:@selector(numeroPuntuaciones)], @"No tiene el método numeroPuntuaciones");
    STAssertTrue( [gestorPuntuaciones respondsToSelector:@selector(damePuntuacionConClave:)], @"No tiene el método damePuntuacionConClave");
    
}

@end